function init()
    SetString("game.tool.bomb.name","LaserBomb")
    
	deflectors = FindBodies("mirror2", true)
    
	laserLoop = LoadLoop("MOD/data/snd/laser-loop.ogg")
    laserHitLoop = LoadLoop("MOD/data/snd/laser-hit-loop.ogg")
	laserHitSound = LoadSound("light/spark0.ogg")
    beepSound = LoadSound("warning-beep")
    placeSounds = {
        LoadSound("metal/hit-s0"),
        LoadSound("metal/hit-s1"),
        LoadSound("metal/hit-s2"),
        LoadSound("metal/hit-s3"),
        LoadSound("metal/hit-s4"),
        LoadSound("metal/hit-s5")
    }
    
	laserSprite = LoadSprite("gfx/laser.png")
    lasers = {}
    explosionQueue = {}
    ui = false
    VOXEL_COUNT = 27
    PLAYER_HIT_RADIUS = 0.4
    MAX_DIST = 200
    MAX_LASERS = 50
    ENABLED = true
    OPTION_GLOBAL_KEYS = false
    OPTION_EXPLODE = false
    OPTION_EXPLODE_TIME = 2
    OPTION_EXPLODE_SIZE = 1
    OPTION_STICKY = true
    OPTION_POWER = 1
    OPTION_SMOKE = true
    OPTION_DIRECTION_UP = true
    OPTION_DIRECTION_LEFT = false
    OPTION_DIRECTION_RIGHT = false
    OPTION_DIRECTION_FORWARD = false
    OPTION_DIRECTION_BACKWARD = false
    OPTION_BREAKS = false
    OPTION_ROTATE = true
    OPTION_ROTATE_SPEED = 1
    OPTION_TRIGGER = false
    OPTION_PLAYER_DAMAGE = false
    OPTION_DEPTH = 1

    -- init settings
    if GetString("savegame.mod.maxlasers")          == "" then SetString("savegame.mod.maxlasers","50") end
    if GetString("savegame.mod.distance")           == "" then SetString("savegame.mod.distance","200") end
    if GetString("savegame.mod.power")              == "" then SetString("savegame.mod.power","Normal") end
    if GetString("savegame.mod.depth")              == "" then SetString("savegame.mod.depth","Normal") end
    if GetString("savegame.mod.breaks")             == "" then SetString("savegame.mod.breaks","No") end
    if GetString("savegame.mod.rotate")             == "" then SetString("savegame.mod.rotate","No") end
    if GetString("savegame.mod.rotatespeed")        == "" then SetString("savegame.mod.rotatespeed","Slow") end
    if GetString("savegame.mod.directions")         == "" then SetString("savegame.mod.directions","Up") end
    if GetString("savegame.mod.smoke")              == "" then SetString("savegame.mod.smoke","No") end
    if GetString("savegame.mod.trigger")            == "" then SetString("savegame.mod.trigger","No") end
    if GetString("savegame.mod.playerdamage")       == "" then SetString("savegame.mod.playerdamage","No") end
    if GetString("savegame.mod.explode")            == "" then SetString("savegame.mod.explode","No") end
    if GetString("savegame.mod.explodetime")        == "" then SetString("savegame.mod.explodetime","3 sec") end
    if GetString("savegame.mod.explodesize")        == "" then SetString("savegame.mod.explodesize","Normal") end
    if GetString("savegame.mod.keytoggle")          == "" then SetString("savegame.mod.keytoggle","T") end
    if GetString("savegame.mod.keytogglesingle")    == "" then SetString("savegame.mod.keytogglesingle","C") end
    if GetString("savegame.mod.keyclear")           == "" then SetString("savegame.mod.keyclear","K") end
    if GetString("savegame.mod.keysglobal")         == "" then SetString("savegame.mod.keysglobal","Yes") end
    if GetString("savegame.mod.color")              == "" then SetString("savegame.mod.color","Red") end
    
end

function tick(dt)

    OPTION_DIRECTION_UP = false
    OPTION_DIRECTION_W  = false
    OPTION_DIRECTION_E  = false
    OPTION_DIRECTION_N  = false
    OPTION_DIRECTION_S  = false

    local propDirections = GetString("savegame.mod.directions")
    if propDirections == "All" then
        OPTION_DIRECTION_UP = true
        OPTION_DIRECTION_W  = true
        OPTION_DIRECTION_E  = true
        OPTION_DIRECTION_N  = true
        OPTION_DIRECTION_S  = true
    elseif propDirections == "Up" then
        OPTION_DIRECTION_UP = true
    elseif propDirections == "Left" then
        OPTION_DIRECTION_W  = true
    elseif propDirections == "Right" then
        OPTION_DIRECTION_E  = true
    elseif propDirections == "Forward" then
        OPTION_DIRECTION_N  = true
    elseif propDirections == "Backward" then
        OPTION_DIRECTION_S  = true
    elseif propDirections == "Left+Right" then
        OPTION_DIRECTION_W  = true
        OPTION_DIRECTION_E  = true
    elseif propDirections == "Fwd+Bkwd" then
        OPTION_DIRECTION_N  = true
        OPTION_DIRECTION_S  = true
    elseif propDirections == "L+R+F+B" then
        OPTION_DIRECTION_W  = true
        OPTION_DIRECTION_E  = true
        OPTION_DIRECTION_N  = true
        OPTION_DIRECTION_S  = true
    end

    local propMaxLasers = GetString("savegame.mod.maxlasers")
    if propMaxLasers == "Infinite" then
        MAX_LASERS = 9999
    else
        MAX_LASERS = tonumber(propMaxLasers)
    end

    local propDepth = GetString("savegame.mod.depth")
    if propDepth == "Normal" then
        OPTION_DEPTH = 1
    else
        OPTION_DEPTH = tonumber(propDepth)
    end
    
    local propPower = GetString("savegame.mod.power")
    if propPower == "Useless" then
        OPTION_POWER = 0
    elseif propPower == "Normal" then
        OPTION_POWER = 1
    elseif propPower == "Strong" then
        OPTION_POWER = 4
    elseif propPower == "Insane" then
        OPTION_POWER = 8
    end
    
    local propDistance = GetString("savegame.mod.distance")
    MAX_DIST = tonumber(propDistance)

    local propSmoke = GetString("savegame.mod.smoke")
    if propSmoke == "Yes" then
        OPTION_SMOKE = true
    elseif propSmoke == "No" then
        OPTION_SMOKE = false
    end

    local propPlayerdamage = GetString("savegame.mod.playerdamage")
    if propPlayerdamage == "Yes" then
        OPTION_PLAYER_DAMAGE = true
    elseif propPlayerdamage == "No" then
        OPTION_PLAYER_DAMAGE = false
    end

    local propBreaks = GetString("savegame.mod.breaks")
    if propBreaks == "Yes" then
        OPTION_BREAKS = true
    elseif propBreaks == "No" then
        OPTION_BREAKS = false
    end

    local propTrigger = GetString("savegame.mod.trigger")
    if propTrigger == "Yes" then
        OPTION_TRIGGER = true
    elseif propTrigger == "No" then
        OPTION_TRIGGER = false
    end

    local propRotate = GetString("savegame.mod.rotate")
    if propRotate == "Yes" then
        OPTION_ROTATE = true
    elseif propRotate == "No" then
        OPTION_ROTATE = false
    end

    local propRotatespeed = GetString("savegame.mod.rotatespeed")
    if propRotatespeed == "Super Slow" then
        OPTION_ROTATE_SPEED = 0.01
    elseif propRotatespeed == "Very Slow" then
        OPTION_ROTATE_SPEED = 0.1
    elseif propRotatespeed == "Medium Slow" then
        OPTION_ROTATE_SPEED = 0.5
    elseif propRotatespeed == "Slow" then
        OPTION_ROTATE_SPEED = 1
    elseif propRotatespeed == "Medium" then
        OPTION_ROTATE_SPEED = 4
    elseif propRotatespeed == "Fast" then
        OPTION_ROTATE_SPEED = 10
    elseif propRotatespeed == "Super Fast" then
        OPTION_ROTATE_SPEED = 20
    end

    local propExplode = GetString("savegame.mod.explode")
    if propExplode == "Yes" then
        OPTION_EXPLODE = true
    elseif propExplode == "No" then
        OPTION_EXPLODE = false
    end
    
    local propExplodeTime = GetString("savegame.mod.explodetime")
    if propExplodeTime == "Instant" then
        OPTION_EXPLODE_TIME = 0
    elseif propExplodeTime == "2 sec" then
        OPTION_EXPLODE_TIME = 2
    elseif propExplodeTime == "3 sec" then
        OPTION_EXPLODE_TIME = 3
    elseif propExplodeTime == "5 sec" then
        OPTION_EXPLODE_TIME = 5
    elseif propExplodeTime == "10 sec" then
        OPTION_EXPLODE_TIME = 10
    end

    local propExplodeSize = GetString("savegame.mod.explodesize")
    if propExplodeSize == "Small" then
        OPTION_EXPLODE_SIZE = 0.1
    elseif propExplodeSize == "Normal" then
        OPTION_EXPLODE_SIZE = 1.5
    elseif propExplodeSize == "Large" then
        OPTION_EXPLODE_SIZE = 3
    end

    local propKeyToggle = GetString("savegame.mod.keytoggle")
    local propKeyToggleSingle = GetString("savegame.mod.keytogglesingle")
    local propKeyClear = GetString("savegame.mod.keyclear")
    local propKeysGlobal = GetString("savegame.mod.keysglobal")
    local propColor = GetString("savegame.mod.color")
    
    local checkInput = false
        
    if GetString("game.player.tool") == "bomb" then
        checkInput = true
    end
        
    if checkInput or propKeysGlobal == "Yes" then
        if InputPressed(string.lower(propKeyClear)) then
            for i=#lasers,1,-1 do
                local laser = lasers[i]
                laser.remove = true
            end
        end

        if InputPressed(string.lower(propKeyToggle)) then
            ENABLED = not ENABLED
            for i=1,#lasers do
                local laser = lasers[i]
                laser.enabled = ENABLED
                laser.triggered = false
                laser.triggers = {0,0,0,0,0}
            end
        end
        
        if InputPressed(string.lower(propKeyToggleSingle)) then
            local t = GetCameraTransform()
            local dir = TransformToParentVec(t, Vec(0, 0, - 1))
            local hit, dist, normal, shape = QueryRaycast(t.pos, dir, 100)
            if hit then
                for i=1,#lasers do
                    local laser = lasers[i]
                    if laser.shape == shape then
                        laser.enabled = not laser.enabled
                        laser.triggered = false
                        laser.triggers = {0,0,0,0,0}
                    end
                end
            end
        end
    end

    
    prelasers = FindShapes("bomb",true)
    for i=1, #prelasers do
        local laser = prelasers[i]
        if GetShapeVoxelCount(laser) == VOXEL_COUNT then
            RemoveTag(laser,"bomb")
            RemoveTag(laser,"smoke")
            SetTag(laser,"nocull")
            if OPTION_BREAKS then
                RemoveTag(laser,"unbreakable")
            end
            if #lasers > MAX_LASERS-1 then
                Delete(lasers[1].shape)
                table.remove(lasers,1)
            end
            local colorRed = {r=1.0,g=0.1,b=0.1}
            local colorGreen = {r=0.1,g=1.0,b=0.1}
            local colorBlue = {r=0.1,g=0.1,b=1.0}
            local colorYellow = {r=1.0,g=1.0,b=0.1}
            local colorCyan = {r=0.1,g=1.0,b=1.0}
            local colorMagenta = {r=1.0,g=0.1,b=1.0}
            local colorWhite = {r=1.0,g=1.0,b=1.0}
            local colors = {colorRed,colorBlue,colorGreen,colorYellow,colorCyan,colorMagenta}
            
            local color = colorRed -- default
            if propColor == "Green" then
                color = colorGreen
            elseif propColor == "Blue" then
                color = colorBlue
            elseif propColor == "Yellow" then
                color = colorYellow
            elseif propColor == "Cyan" then
                color = colorCyan
            elseif propColor == "Magenta" then
                color = colorMagenta
            elseif propColor == "White" then
                color = colorWhite
            elseif propColor == "Random" then
                color = colors[math.random(1,#colors)]
            end
            
            PlaySound(placeSounds[math.random(1,#placeSounds)],GetShapeWorldTransform(laser).pos,1)
            
            table.insert(lasers,{shape=laser,dist=0,hitscale=0,bombtimer=0,lastbeeptime=0,color=color,remove=false,enabled=ENABLED,rotation=0,triggered=false,triggers={0,0,0,0,0},triggersound=0})
        end
    end

    -- DebugWatch("lasers",#lasers)
    for i=1, #lasers do
        laserCalc(lasers[i], dt)
    end
    for i=#lasers, 1, -1 do
        local laser = lasers[i]
        if laser.remove then
            Delete(laser.shape)
            table.remove(lasers,i)
        end
    end
    
    ExplosionQueueNext()
	
end

function laserCalc(laser, dt)
    if IsShapeBroken(laser.shape) then
        laser.remove = true
    end
    
    if OPTION_EXPLODE then
        if OPTION_TRIGGER then
            if laser.triggered then
                laser.bombtimer = laser.bombtimer + dt
            end
        else
            laser.triggered = true
            laser.bombtimer = laser.bombtimer + dt
        end

        if laser.lastbeeptime < laser.bombtimer then
            local nextbeep = (OPTION_EXPLODE_TIME-laser.bombtimer)/4
            if nextbeep < 0.08 then nextbeep = 0.08 end
            laser.lastbeeptime = laser.bombtimer + nextbeep
            PlaySound(beepSound,GetShapeWorldTransform(laser.shape).pos,1)
        end
        -- DebugPrint(laser.bombtimer)
        if laser.bombtimer > OPTION_EXPLODE_TIME  then
            ExplosionQueueAdd(GetShapeWorldTransform(laser.shape).pos,OPTION_EXPLODE_SIZE)
            laser.remove = true
        end
    end
    
    SetShapeEmissiveScale(laser.shape, 0)
    
    if laser.enabled then
        local emitTransformOffset = Transform(Vec(0.15,0.15,0.15),QuatEuler(0,0,0))
        local emitTransform = TransformToParentTransform(GetShapeWorldTransform(laser.shape),emitTransformOffset)
        local origin = emitTransform.pos
        -- DebugPrint(laser.lastbeeptime - laser.bombtimer)
        SetShapeEmissiveScale(laser.shape, rnd(0.0, 0.1))
        
        if laser.triggered then
            if ((laser.lastbeeptime - laser.bombtimer) > 0 and (laser.lastbeeptime - laser.bombtimer) < 0.1 or (laser.lastbeeptime - laser.bombtimer) > 0.6) or laser.triggersound > 0.05 then
                SetShapeEmissiveScale(laser.shape, rnd(0.5, 1.0))
                PointLight(origin, laser.color.r, laser.color.g, laser.color.b, rnd(0.5, 1.0))
            end
        end



        PlayLoop(laserLoop, origin, 0.5)
        
        if OPTION_ROTATE then
            if OPTION_ROTATE_SPEED >= 1 then
                laser.rotation = laser.rotation + OPTION_ROTATE_SPEED + math.random()/10
            else
                laser.rotation = laser.rotation + OPTION_ROTATE_SPEED + (math.random()/10) * OPTION_ROTATE_SPEED
            end
        end
        
        
        if OPTION_DIRECTION_UP then
            local dir = TransformToParentVec(emitTransform, Vec(0, 0, 1))
            shootLaserWithDirection(laser,origin,dir,dt,1,1)
        end

        local dirTransform = TransformCopy(emitTransform)
        dirTransform.rot = QuatRotateQuat(dirTransform.rot,QuatEuler(0,0,laser.rotation))

        if OPTION_DIRECTION_W then
            local dir = TransformToParentVec(dirTransform,Vec(-1,0,0))
            shootLaserWithDirection(laser,origin,dir,dt,2,1)
        end

        if OPTION_DIRECTION_E then
            local dir = TransformToParentVec(dirTransform, Vec(1, 0, 0))
            shootLaserWithDirection(laser,origin,dir,dt,3,1)
        end

        if OPTION_DIRECTION_N then
            local dir = TransformToParentVec(dirTransform, Vec(0, 1, 0))
            shootLaserWithDirection(laser,origin,dir,dt,4,1)
        end

        if OPTION_DIRECTION_S then
            local dir = TransformToParentVec(dirTransform, Vec(0, -1, 0))
            shootLaserWithDirection(laser,origin,dir,dt,5,1)
        end
        
    end

end

function ExplosionQueueAdd(pos,size)
    table.insert(explosionQueue,{pos,size})
end
function ExplosionQueueNext()
    if #explosionQueue >= 1 then
        local next = table.remove(explosionQueue,1)
        local pos = next[1]
        local size = next[2]
        Explosion(pos,size)
    end
end




function shootLaserWithDirection(laser,origin,dir,dt,triggerindex,depth)
    local length, hitPoint, hitBody, hitShape, hit, deflectorsHit, hitDirection = shootLaser(GetShapeBody(laser.shape), laser.shape, origin, dir, 0, laser.color, {})
    if length ~= laser.dist then
        laser.hitscale = 1
        laser.dist = length
    end
    laser.hitscale = math.max(0.0, laser.hitscale - dt)
    if laser.hitscale > 0 then
        PlayLoop(laserHitLoop, endPoint, laser.hitscale)
        PointLight(hitPoint, laser.color.r, laser.color.g, laser.color.b, rnd(2.0, 4.0)*laser.hitscale)
    end
    PointLight(hitPoint, laser.color.r, laser.color.g, laser.color.b, rnd(0.5, 1.0))
    
    if hit then
        if OPTION_TRIGGER then
            if laser.dist >= laser.triggers[triggerindex] then
                laser.triggers[triggerindex] = laser.dist
                laser.triggered = false
            else
                laser.triggered = true
                laser.triggersound = laser.triggersound + dt
                if laser.triggersound > 0.1 and not OPTION_EXPLODE then
                    PlaySound(beepSound,origin,2)
                    laser.triggersound = 0
                end
            end
        end

        if OPTION_SMOKE then
            emitSmoke(hitPoint, 1.0)
        end
        if OPTION_POWER > 0 and OPTION_POWER <= 1 then
            MakeHole(hitPoint, 0.5 * OPTION_POWER, 0.3 * OPTION_POWER, 0, true)
        end
        if OPTION_POWER > 1 then
            MakeHole(hitPoint, 0.5 * OPTION_POWER, 0.3 * OPTION_POWER, OPTION_POWER, true)
        end
        
        if depth < OPTION_DEPTH then
            local fwdHitPoint = VecAdd(hitPoint,VecScale(hitDirection,0.2))
            depth = depth + 1
            shootLaserWithDirection(laser,fwdHitPoint,hitDirection,dt,triggerindex,depth)
        end
    
    end
end


function rnd(mi, ma)
	return math.random(1000)/1000*(ma-mi) + mi
end


function rndVec(t)
	return Vec(rnd(-t, t), rnd(-t, t), rnd(-t, t))
end 


function emitSmoke(pos, amount)
	ParticleReset()
	ParticleType("smoke")
	ParticleColor(0.8, 0.8, 0.8)
	ParticleRadius(0.2, 0.4)
	ParticleAlpha(0.5, 0)
	ParticleDrag(0.5)
	ParticleGravity(rnd(0.0, 2.0))
	SpawnParticle(VecAdd(pos, rndVec(0.01)), rndVec(0.1), rnd(1.0, 3.0))

	ParticleReset()
	ParticleEmissive(5, 0, "easeout")
	ParticleGravity(-10)
	ParticleRadius(0.01, 0.0, "easein")
	ParticleColor(1, 0.4, 0.3)
	ParticleTile(4)
	local vel = VecAdd(Vec(0, 1, 0), rndVec(2.0))
	SpawnParticle(pos, vel, rnd(1.0, 2.0))
end


function getDistanceToLineSegment(point, p0, p1)
    local line_vec = VecSub(p1, p0)
    local pnt_vec = VecSub(point, p0)
    local line_len = VecLength(line_vec)
    local line_unitvec = VecNormalize(line_vec)
    local pnt_vec_scaled = VecScale(pnt_vec, 1.0/line_len)
    local t = VecDot(line_unitvec, pnt_vec_scaled)    
    if t < 0.0 then
        t = 0.0
    elseif t > 1.0 then
        t = 1.0
	end
    local nearest = VecScale(line_vec, t)
    local dist = VecLength(VecSub(nearest, pnt_vec))
    local nearest = VecAdd(nearest, p0)
    return dist, nearest
end


function shootLaser(body, shape, origin, dir, currentLength, color, deflectorsHit)
	--Raycast
	QueryRequire("physical")
	if shape ~= 0 then
		QueryRejectShape(shape)
	end
	if body ~= 0 then
		-- QueryRejectBody(body)
	end
	local hit, hitDist, hitNormal, hitShape = QueryRaycast(origin, dir, MAX_DIST, 0.0, true)
	local length = MAX_DIST
	if hit then
		length = hitDist
	end
	local hitPoint = VecAdd(origin, VecScale(dir, length))
	
	local t = Transform(VecLerp(origin, hitPoint, 0.5))
	local xAxis = VecNormalize(VecSub(hitPoint, origin))
	local zAxis = VecNormalize(VecSub(origin, GetCameraTransform().pos))
	t.rot = QuatAlignXZ(xAxis, zAxis)
	DrawSprite(laserSprite, t, length, 0.05+math.random()*0.01, 8, 4, 4, 1, true, true)
	DrawSprite(laserSprite, t, length, 0.5, color.r, color.g, color.b, 1, true, true)
    
    --Check if player if hit by laser
    if OPTION_PLAYER_DAMAGE then
    	local ppos = GetPlayerCameraTransform().pos
    	ppos[2] = ppos[2] - PLAYER_HIT_RADIUS*0.5
    	local pdist, phit = getDistanceToLineSegment(ppos, origin, hitPoint)
    	if pdist < PLAYER_HIT_RADIUS then
    		--Decrease health but don't kill
    		local health = GetPlayerHealth()
    		health = math.max(0.1, health - 0.3)
    		SetPlayerHealth(health)
    		ReleasePlayerGrab()
        
    		--Disance to player, without vertical component
    		local pdir = VecSub(ppos, phit)
    		pdir[2] = 0
    		pdir = VecNormalize(pdir)
        
    		--Move player and give a nudge
    		local pt = GetPlayerTransform(true)
    		pt.pos = VecAdd(pt.pos, VecScale(pdir, PLAYER_HIT_RADIUS-pdist+0.1))
    		SetPlayerTransform(pt, true)
    		SetPlayerVelocity(VecScale(pdir, 10))
        
    		--Play hit sound
    		PlaySound(laserHitSound, ppos)
    	end
    end

    --Check if directed
	local hitBody = GetShapeBody(hitShape)
	if HasTag(hitBody, "mirror2") and currentLength < MAX_DIST then
		--Only allow the beam to hit a deflector once
		local alreadyHit = false
		for i=1, #deflectorsHit do
			if deflectorsHit[i] == hitBody then
				alreadyHit = true
				break
			end
		end
		if not alreadyHit then
			deflectorsHit[#deflectorsHit+1] = hitBody
			local t = GetBodyTransform(hitBody)
			local refDir = TransformToParentVec(t, Vec(0, 0, 1))
			SetShapeEmissiveScale(hitShape, 1)
			return shootLaser(hitBody, hitShape, t.pos, refDir, currentLength + length, color, deflectorsHit)
		end
	end

	--Check if reflected
	local hitBody = GetShapeBody(hitShape)
    -- SetTag(hitBody,"mirror")
	if HasTag(hitBody, "mirror") and currentLength < MAX_DIST and hitDist > 0.001 then
		local refDir = VecSub(dir, VecScale(hitNormal, VecDot(hitNormal, dir)*2))
		return shootLaser(hitBody, hitShape, hitPoint, refDir, currentLength + length, color, deflectorsHit)
	end
	return currentLength + length, hitPoint, hitBody, hitShape, hit, deflectorsHit, dir
end


--Helper function for UI to configure properties
function property(name, list, key)
	local current = GetString(key)
	if current == "" then 
		current = list[1]
	end
	UiPush()
        UiColor(1, 1, 1, 0.7)
		UiFont("bold.ttf", 26)
		UiText(name)
		UiTranslate(250, 0)
        UiColor(1, 1, 1, 1)
		UiFont("bold.ttf", 26)
		if UiTextButton(current,100) then
            local new = nil
            if InputDown('shift') then
                for i=2, #list do
    				if list[i] == current then
    					new = list[i-1]		
    				end
    			end
    			if new then
    				SetString(key, new)
    			else
    				SetString(key, list[#list])
    			end
            else
                for i=1, #list-1 do
    				if list[i] == current then
    					new = list[i+1]		
    				end
    			end
    			if new then
    				SetString(key, new)
    			else
    				SetString(key, list[1])
    			end
            end
		end


	UiPop()
end


--Configuration UI
function draw()
	if GetString("game.player.tool") == "bomb" then
        
        local propMenuHint = GetString("savegame.mod.menuhint")
        
		UiFont("regular.ttf", 22)
		UiTextShadow(0, 0, 0, 0.5, 0.5)

		local uix = UiWidth() - 220
		local uiy = 30

        local openx = 15
        local openy = UiMiddle() - 636/2

		if InputPressed(string.lower("m")) then
			ui = not ui
		end

		if ui then
            UiTranslate(openx, openy)

            UiPush()
                UiTranslate(-50, -35)
                UiColor(0, 0, 0, 0.95)
                UiImageBox("ui/common/box-solid-6.png", 450, 636, 6, 6)
            UiPop()
            UiColor(1,1,1,1)

			UiMakeInteractive()
			UiText("Press M to hide")
			UiTranslate(0, 25)
            UiColor(0.5,0.5,0.5,1)
            UiText("Shift press goes backwards")
			UiTranslate(0, 30)
			property("Maximum Lasers", {"25", "50", "100", "200", "Infinite"}, "savegame.mod.maxlasers")
            UiTranslate(0, 26)
            property("Laser Distance", {"1", "2", "5", "10", "25", "50", "100", "200"}, "savegame.mod.distance")
			UiTranslate(0, 26)
            property("Laser Power", {"Useless", "Normal", "Strong", "Insane"}, "savegame.mod.power")
			UiTranslate(0, 26)
            property("Laser Depth", {"Normal", "5", "10", "20", "50", "100"}, "savegame.mod.depth")
			UiTranslate(0, 26)
            property("Laser Smoke", {"Yes", "No"}, "savegame.mod.smoke")
			UiTranslate(0, 26)
            property("Laser Color", {"Red", "Green", "Blue", "Yellow", "Cyan", "Magenta", "White", "Random"}, "savegame.mod.color")
			UiTranslate(0, 26)
            property("Laser Directions", {"None", "Up", "Left", "Right", "Left+Right", "Forward", "Backward", "Fwd+Bkwd", "L+R+F+B", "All"}, "savegame.mod.directions")
			UiTranslate(0, 26)
            property("Laser Breaks", {"No", "Yes"}, "savegame.mod.breaks")
			UiTranslate(0, 26)
            property("Laser Rotates", {"No", "Yes"}, "savegame.mod.rotate")
			UiTranslate(0, 26)
            property("Laser Rotation Speed", {"Super Slow", "Very Slow", "Medium Slow", "Slow", "Medium", "Fast", "Super Fast"}, "savegame.mod.rotatespeed")
			UiTranslate(0, 26)
            property("Player Damage", {"No", "Yes"}, "savegame.mod.playerdamage")
			UiTranslate(0, 26)
            property("Trigger", {"No", "Yes"}, "savegame.mod.trigger")
			UiTranslate(0, 26)
            property("Explode", {"No", "Yes"}, "savegame.mod.explode")
			UiTranslate(0, 26)
            property("Explode Time", {"Instant", "2 sec", "3 sec", "5 sec", "10 sec"}, "savegame.mod.explodetime")
			UiTranslate(0, 26)
            property("Explode Size", {"Small", "Normal", "Large"}, "savegame.mod.explodesize")
			UiTranslate(0, 26)
            property("Key Toggle", {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","Q","R","S","T","U","V","W","X","Y","Z"}, "savegame.mod.keytoggle")
			UiTranslate(0, 26)
            property("Key Toggle Single", {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","Q","R","S","T","U","V","W","X","Y","Z"}, "savegame.mod.keytogglesingle")
			UiTranslate(0, 26)
            property("Key Clear",  {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","Q","R","S","T","U","V","W","X","Y","Z"}, "savegame.mod.keyclear")
			UiTranslate(0, 26)
            property("Keys Global",  {"Yes", "No"}, "savegame.mod.keysglobal")
			UiTranslate(0, 26)
            property("Show Menu Hint",  {"Yes", "No"}, "savegame.mod.menuhint")
			UiTranslate(0, 32)
            
            -- reset 
            UiColor(1, 0.2, 0.2, 1)
    		UiFont("bold.ttf", 22)
    		if UiTextButton("SET DEFAULTS",100) then
                resetOptions()
            end
            
            UiTranslate(200,0)
            UiColor(1.0, 0.8, 0.2, 1)
            if UiTextButton("SET DEFAULT BOMB",100) then
                resetOptionsDefaultBomb()
            end

		else

            if propMenuHint == "Yes" then
                UiTranslate(uix, uiy)
                UiText("Press M for Laser Menu")
            end

		end
	end
end


function resetOptions()
    SetString("savegame.mod.maxlasers","50")
    SetString("savegame.mod.distance","200")
    SetString("savegame.mod.power","Normal")
    SetString("savegame.mod.depth","Normal")
    SetString("savegame.mod.smoke","No")
    SetString("savegame.mod.directions","Up")
    SetString("savegame.mod.breaks","No")
    SetString("savegame.mod.trigger","No")
    SetString("savegame.mod.rotate","No")
    SetString("savegame.mod.rotatespeed","Slow")
    SetString("savegame.mod.explode","No")
    SetString("savegame.mod.explodetime","3 sec")
    SetString("savegame.mod.explodesize","Normal")
    SetString("savegame.mod.playerdamage","No")
    SetString("savegame.mod.keytoggle","T")
    SetString("savegame.mod.keyclear","K")
    SetString("savegame.mod.keytogglesingle","C")
    SetString("savegame.mod.keysglobal","Yes")
    SetString("savegame.mod.color","Red")
    SetString("savegame.mod.menuhint","Yes")
end


function resetOptionsDefaultBomb()
    SetString("savegame.mod.maxlasers","50")
    SetString("savegame.mod.distance","200")
    SetString("savegame.mod.power","Normal")
    SetString("savegame.mod.depth","Normal")
    SetString("savegame.mod.smoke","No")
    SetString("savegame.mod.directions","None")
    SetString("savegame.mod.breaks","No")
    SetString("savegame.mod.trigger","No")
    SetString("savegame.mod.rotate","No")
    SetString("savegame.mod.rotatespeed","Slow")
    SetString("savegame.mod.explode","Yes")
    SetString("savegame.mod.explodetime","3 sec")
    SetString("savegame.mod.explodesize","Normal")
    SetString("savegame.mod.playerdamage","No")
    SetString("savegame.mod.keytoggle","T")
    SetString("savegame.mod.keyclear","K")
    SetString("savegame.mod.keytogglesingle","C")
    SetString("savegame.mod.keysglobal","Yes")
    SetString("savegame.mod.color","Red")
    SetString("savegame.mod.menuhint","Yes")
end


